main()
{
	teleport();
	fire_and_smoke();
	elevator();
}

teleport();
{
entTransporter = getentarray("transporter","targetname");
  if(isdefined(entTransporter))
  {
    for(lp=0;lp<entTransporter.size;lp=lp+1)
      entTransporter[lp] thread Transporter();
  }

  entHealthPad = getentarray("healthpad","targetname");
  if(isdefined(entHealthPad))
  {
    for(lp=0;lp<entHealthPad.size;lp=lp+1)
      entHealthPad[lp] thread HealthPad();
  }
}

Transporter()
{
  while(true)
  {
    self waittill("trigger",other);
    entTarget = getent(self.target, "targetname");

//    other playsound("TransportOut");
    wait(0.10);
    other setorigin(entTarget.origin);
    other setplayerangles(entTarget.angles);
//    other playsound("TransportIn");
    wait(0.10);
  }
}

HealthPad()
{
  while(true)
  {
    self waittill("trigger", other);
    if(other.health < other.maxhealth)
    {
//      other playsound("HealthPad");
      other.health = other.health+1;
      wait(0.50);
    }
  }
}

fire_and_smoke()
{
level._effect["fire"] = loadfx ("fx/fire/tinybon.efx");
maps\mp\_fx::loopfx("fire", (-128, 128, 16), 0.6);
level._effect["smoke"] = loadfx ("fx/smoke/ash_smoke.efx");
maps\mp\_fx::loopfx("smoke", (-128, 128, 80), 0.7);
maps\mp\_load::main();
}

// Original by lordblank
// Rewritten by Snake Shift

elevator()
{
level.elevatorDown = false; // elevator starts at bottom: true/false
level.elevatorMoving = false; // elevator is not currently moving
thread elevator_start();
}

elevator_start() {
elevator = getentarray ("elevatorswitch","targetname");
if ( isdefined(elevator) )
for (i = 0; i < elevator.size; i++)
 elevator[i] thread elevator_think();
}

elevator_think() {
while (1) {
self waittill ("trigger");
if (!level.elevatorMoving)
 thread elevator_move();
}
}

elevator_move() {

elevatormodel = getent ("elevatormodel", "targetname");
level.elevatorMoving = true;

speed = 3;
height = 128;

wait (1);

if (level.elevatorDown) { // moves to top
elevatormodel moveZ (height, speed);
elevatormodel waittill ("movedone");
level.elevatorDown = false;

} else { // moves to bottom
elevatormodel moveZ (height - (height * 2), speed);
elevatormodel waittill ("movedone");
level.elevatorDown = true;
}
level.elevatorMoving = false;
}